unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLWin32Viewer, GLScene, GLObjects, GLCoordinates, GLCrossPlatform,
  BaseClasses,jpeg, StdCtrls, GLGeomObjects, ComCtrls, VectorTypes;

type
  TForm1 = class(TForm)
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLDummyCube1: TGLDummyCube;
    GLCube1: TGLCube;
    GLSceneViewer1: TGLSceneViewer;
    GLLightSource2: TGLLightSource;
    GLSphere1: TGLSphere;
    GLCylinder1: TGLCylinder;
    Button1: TButton;
    Button2: TButton;
    GLPlane1: TGLPlane;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    TrackBar2: TTrackBar;
    Label3: TLabel;
    Label4: TLabel;
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    px,py : integer;
    colOR : TVector4f;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  colOR := GLLightSource2.Diffuse.Color;
end;

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  px := X; py := Y;
end;


procedure TForm1.GLSceneViewer1MouseMove(Sender: TObject;
  Shift: TShiftState;
  X, Y: Integer);
begin
  if ssLeft in Shift then begin
    GLCamera1.MoveAroundTarget(py-Y,px-X);
    px := X; py := Y;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  GLSphere1.Material.Texture.Image.LoadFromFile('./texts/tucan.jpg');
  GLSphere1.Material.Texture.Enabled := true;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  GLCylinder1.Material.Texture.Image.LoadFromFile('./texts/guaca.jpg');
  GLCylinder1.Material.Texture.Enabled := true;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
var
 vv : integer;
 vr : single;
begin
  vv := TrackBar1.Position;
  Label1.Caption := IntToStr(vv);

  vr := vv/100;
  GLLightSource1.Diffuse.SetColor(vr,vr,vr);
end;


procedure TForm1.TrackBar2Change(Sender: TObject);
var
 vv  : integer;
 vr  : single;
begin
  vv := TrackBar2.Position;
  Label3.Caption := IntToStr(vv);

  vr := vv/100;

  GLLightSource2.Diffuse.SetColor(colOR[0]*vr,
                                  colOR[1]*vr,
                                  colOR[2]*vr);
end;

end.
